Summary: qmail
Summary(ja): qmail
Name: qmail
Version: 1.03
Release: 1ng4
License: Public Domain
Group: System Environment/Daemons
URL: http://cr.yp.to/qmail.html
Source0: http://cr.yp.to/software/qmail-%{version}.tar.gz
Source1: http://www.org3.net/software/qmail-service-%{version}.tar.gz
Source2: libdomainkeys-0.68.tar.gz

Patch0: qmail-%{version}.errno.patch
Patch1: qmail-%{version}.qmail_local.patch
Patch2: qmail-%{version}.qmail_smtpd.patch
Patch3: qmail-%{version}.date-localtime.patch
Patch4: qmail-%{version}.qmailqueue.patch
Patch5: qmail-%{version}.v6.patch
Patch6: qmail-%{version}+v6.tls.patch
Patch7: qmail-%{version}+v6+tls.auth.patch
Patch8: qmail-%{version}+v6+tls+auth.vida.patch
Patch9: qmail-%{version}-dk-0.54.patch
Patch10: qmail-%{version}-spf-rc5.patch

Patch100: qmail-%{version}.install.patch

Provides:  smtpdaemon
Conflicts: sendmail postfix

Buildroot: %{_tmppath}/%{name}-%{version}-root
Requires: glibc >= 2.0.6, openssl >= 0.9.7d, checkpassword >= 0.90, ucspi-tcp >= 0.88

Packager: NOGUCHI Shoji <noguchi@org3.net>

%description
qmail is a secure, reliable, efficient, simple message transfer agent. It is designed for typical Internet-connected UNIX hosts. As of October 2001, qmail is the second most common SMTP server on the Internet, and has by far the fastest growth of any SMTP server. 

%prep
%setup -q -a 1 -a 2
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1

%patch100 -p1

echo %__cc -DINET6 -DTLS=20040419 -I%{_includedir}/openssl $RPM_OPT_FLAGS > conf-cc
echo %{_var}/qmail > conf-qmail
echo %__cc -s $RPM_OPT_FLAGS > conf-ld
echo $RPM_BUILD_ROOT%{_mandir} > conf-man
echo $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version} > conf-doc

%__rm -f *.orig *~

%build
cd libdomainkeys-0.68
echo '-lresolv' > dns.lib
%__make

cd ../
%__sed -i 's!\.\./\(domainkeys\)!libdomainkeys-0.68/\1!' qmail-dk.c
%__sed -i 's!\.\./\(libdomainkeys\)!libdomainkeys-0.68/\1!' Makefile
%__make
%__make man

%install
[ "$RPM_BUILD_ROOT" != "/" ] && %__rm -rf $RPM_BUILD_ROOT

# qmail
%__mkdir_p $RPM_BUILD_ROOT%{_var}
%__mkdir_p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%__mkdir_p $RPM_BUILD_ROOT%{_mandir}/{man1,man5,man7,man8}

auto_split=`head -1 auto_split.c | %__sed -e "s/^.* = \(.*\);/\1/"`

%__cat hier.c | \
  %__grep "^  \([cdhpz]\|dsplit\)(" | \
  %__grep -v "mode" | \
  %__sed -e "s/^  \([cdhpz]\|dsplit\)(\(.*\));/\1,\2/" | \
  %__sed -e "s/[\"]//g" | \
  %__awk -F "," '{ \
    if($1 == "h") \
    { print "%attr(" $5 "," $3 "," $4 ") %dir " $2 } \
    if($1 == "c") \
    { \
      if(substr($3,1,3) == "man") \
      { print "%attr(" $7 "," $5 "," $6 ") " $2 "/" $3 "/" $4 ".gz"} \
      else \
      { print "%attr(" $7 "," $5 "," $6 ") " $2 "/" $3 "/" $4 } \
    } \
    if($1 == "d" ) \
    { print "%attr(" $6 "," $4 "," $5 ") %dir " $2 "/" $3 } \
    if($1 == "p") \
    { print "%attr(" $6 "," $4 "," $5 ") " $2 "/" $3 } \
    if($1 == "z") \
    { print "%attr(" $7 "," $5 "," $6 ") " $2 "/" $3 } \
    if($1 == "dsplit") \
    { \
      { print "%attr(" $4 "," $3 ",auto_gidq) %dir auto_qmail/" $2 } \
      for (i = 0; i < "'${auto_split}'" + 0; i++ ) \
      { print "%attr(" $4 "," $3 ",auto_gidq) %dir auto_qmail/" $2 "/" i } \
    } \
  }' | \
  %__sed -e "s!auto_qmail!%{_var}/qmail!" \
	 -e "s!auto_doc!%{_docdir}/%{name}-%{version}!" \
	 -e "s!auto_man!%{_mandir}!" \
         -e "s!auto_uida!alias!g" \
         -e "s!auto_uido!root!g" \
         -e "s!auto_gidq!qmail!g" \
         -e "s!auto_gidn!nofiles!g" \
         -e "s!auto_gidvida!vida!g" \
         -e "s!auto_.id!qmail!g" > qmail-%{version}.files

echo $RPM_BUILD_ROOT%{_var}/qmail > conf-qmail
%__rm auto_*.o install instcheck
%__make install instcheck

./install
./instcheck

%__mkdir_p $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily
pushd $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily
%__ln_s -f ../..%{_var}/qmail/bin/update_tmprsadh .
popd

#qmail-service
ETC=$RPM_BUILD_ROOT%{_sysconfdir}
VAR=$RPM_BUILD_ROOT%{_localstatedir}

%__mkdir_p $ETC/qmail/service/qmail-send/env
%__mkdir_p $ETC/qmail/service/qmail-send/log
%__mkdir_p $ETC/qmail/service/smtp/env
%__mkdir_p $ETC/qmail/service/smtp/log
%__mkdir_p $ETC/qmail/service/pop3/env
%__mkdir_p $ETC/qmail/service/pop3/log
%__mkdir_p $ETC/qmail/service/pop3s/env
%__mkdir_p $ETC/qmail/service/pop3s/log

%__mkdir_p $VAR/log/qmail-send/main
%__mkdir_p $VAR/log/qmail-send/alert
%__mkdir_p $VAR/log/qmail-smtpd/main
%__mkdir_p $VAR/log/qmail-smtpd/tcp
%__mkdir_p $VAR/log/qmail-pop3d
%__mkdir_p $VAR/log/qmail-pop3d-ssl

%__install -m 755 service/qmail-send/run             $ETC/qmail/service/qmail-send/run
%__install -m 644 service/qmail-send/env/PATH        $ETC/qmail/service/qmail-send/env/PATH
%__install -m 755 service/qmail-send/log/run         $ETC/qmail/service/qmail-send/log/run

%__install -m 755 service/smtp/run                   $ETC/qmail/service/smtp/run
%__install -m 644 service/smtp/env/PATH              $ETC/qmail/service/smtp/env/PATH
%__install -m 644 service/smtp/env/IP                $ETC/qmail/service/smtp/env/IP
%__install -m 644 service/smtp/env/DOMAINOWNER       $ETC/qmail/service/smtp/env/DOMAINOWNER
%__install -m 755 service/smtp/log/run               $ETC/qmail/service/smtp/log/run

%__install -m 755 service/pop3/run                   $ETC/qmail/service/pop3/run
%__install -m 644 service/pop3/env/PATH              $ETC/qmail/service/pop3/env/PATH
%__install -m 644 service/pop3/env/IP                $ETC/qmail/service/pop3/env/IP
%__install -m 644 service/pop3/env/DOMAINOWNER       $ETC/qmail/service/pop3/env/DOMAINOWNER
%__install -m 755 service/pop3/log/run               $ETC/qmail/service/pop3/log/run

%__install -m 755 service/pop3s/run                  $ETC/qmail/service/pop3s/run
%__install -m 644 service/pop3s/env/PATH             $ETC/qmail/service/pop3s/env/PATH
%__install -m 644 service/pop3s/env/IP               $ETC/qmail/service/pop3s/env/IP
%__install -m 644 service/pop3s/env/DOMAINOWNER      $ETC/qmail/service/pop3s/env/DOMAINOWNER
%__install -m 755 service/pop3s/log/run              $ETC/qmail/service/pop3s/log/run


%clean
%__rm -rf $RPM_BUILD_ROOT


%files -f qmail-%{version}.files

%defattr(0644,root,root,0755)
%{_sysconfdir}/cron.daily/update_tmprsadh

%defattr(0644,root,root,0755)
%dir %{_sysconfdir}/qmail
%dir %{_sysconfdir}/qmail/service
%dir %{_sysconfdir}/qmail/service/qmail-send
%dir %{_sysconfdir}/qmail/service/qmail-send/env
%dir %{_sysconfdir}/qmail/service/smtp
%dir %{_sysconfdir}/qmail/service/smtp/env
%dir %{_sysconfdir}/qmail/service/pop3
%dir %{_sysconfdir}/qmail/service/pop3/env
%dir %{_sysconfdir}/qmail/service/pop3s
%dir %{_sysconfdir}/qmail/service/pop3s/env

%defattr(0644,qmaill,root,0755)
%dir %{_sysconfdir}/qmail/service/qmail-send/log

%defattr(0644,qmaild,root,0755)
%dir %{_sysconfdir}/qmail/service/smtp/log

%defattr(0644,qmaill,root,0755)
%dir %{_sysconfdir}/qmail/service/pop3/log
%dir %{_sysconfdir}/qmail/service/pop3s/log

%defattr(0600,qmaill,root,0700)
%dir %{_localstatedir}/log/qmail-send
%dir %{_localstatedir}/log/qmail-send/main
%dir %{_localstatedir}/log/qmail-send/alert

%defattr(0600,qmaild,root,0700)
%dir %{_localstatedir}/log/qmail-smtpd
%dir %{_localstatedir}/log/qmail-smtpd/main
%dir %{_localstatedir}/log/qmail-smtpd/tcp

%defattr(0600,qmaill,root,0700)
%dir %{_localstatedir}/log/qmail-pop3d
%dir %{_localstatedir}/log/qmail-pop3d-ssl

%defattr(0644,root,root)
%config %{_sysconfdir}/qmail/service/qmail-send/env/PATH
%config %{_sysconfdir}/qmail/service/smtp/env/PATH
%config %{_sysconfdir}/qmail/service/smtp/env/IP
%config %{_sysconfdir}/qmail/service/smtp/env/DOMAINOWNER
%config %{_sysconfdir}/qmail/service/pop3/env/PATH
%config %{_sysconfdir}/qmail/service/pop3/env/IP
%config %{_sysconfdir}/qmail/service/pop3s/env/PATH
%config %{_sysconfdir}/qmail/service/pop3s/env/IP

%defattr(0755,root,root)
%config %{_sysconfdir}/qmail/service/qmail-send/run
%config %{_sysconfdir}/qmail/service/qmail-send/log/run
%config %{_sysconfdir}/qmail/service/smtp/run
%config %{_sysconfdir}/qmail/service/smtp/log/run
%config %{_sysconfdir}/qmail/service/pop3/run
%config %{_sysconfdir}/qmail/service/pop3/log/run
%config %{_sysconfdir}/qmail/service/pop3s/run
%config %{_sysconfdir}/qmail/service/pop3s/log/run

%changelog
* Tue Jun 20 2006 NOGUCHI Shoji <noguchi@org3.net> 1.03-0vl2
- ipv6 patch fix. (deprecation of ip6.int)

* Thu Apr 21 2005 NOGUCHI Shoji <noguchi@org3.net> 1.03-0vl1
- rebuild for Vine Linux 3.1
